
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	OR	257
#define	AND	258
#define	REL_EQ	259
#define	REL_NE	260
#define	REL_LE	261
#define	REL_GE	262
#define	LEFT	263
#define	RIGHT	264
#define	UMINUS	265
#define	INDIRECT	266
#define	INCDEC	267
#define	ABS	268
#define	SIGN	269
#define	TYPE	270
#define	EVENT_SRC	271
#define	LOWER_THAN_ELSE	272
#define	ELSE	273
#define	LOWER_THAN_EXPR_SHIFT	274
#define	ID	275
#define	NUMBER	276
#define	ASSIGN	277
#define	ASSIGN2	278
#define	TASKOP	279
#define	JUMP	280
#define	TASK	281
#define	SUB	282
#define	STRING	283
#define	PP_DEFINE	284
#define	PP_INCLUDE	285
#define	NL	286
#define	WS	287
#define	PP_ARG	288
#define	PP_UNKNOWN	289
#define	PP_IFDEF	290
#define	PP_IF	291
#define	PP_ELSE	292
#define	PP_ELIF	293
#define	PP_ENDIF	294
#define	PP_UNDEF	295
#define	PP_PRAGMA	296
#define	PP_GLOM	297
#define	PP_ERROR	298
#define	PP_WARNING	299
#define	IF	300
#define	WHILE	301
#define	DO	302
#define	FOR	303
#define	REPEAT	304
#define	SWITCH	305
#define	CASE	306
#define	DEFAULT	307
#define	MONITOR	308
#define	CATCH	309
#define	ACQUIRE	310
#define	ASM	311
#define	INT	312
#define	T_VOID	313
#define	T_CONST	314
#define	SENSOR	315
#define	TASKID	316
#define	NOLIST	317
#define	CTRUE	318
#define	CFALSE	319

#line 1 "parse.y"

/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of this code is David Baum.
 * Portions created by David Baum are Copyright (C) 1998 David Baum.
 * All Rights Reserved.
 */
#line 19 "parse.y"

// prevent redefinition of YYSTYPE in parser.h
#define __PARSE_TAB_H

// these classes must be defined prior to YYSTYPE
#include "Fragment.h"
#include "BlockStmt.h"
#include "Symbol.h"
#include "Expr.h"
#include "FunctionDef.h"
#include "CallStmt.h"
#include "AsmStmt.h"
#include "LabeledStmt.h"
#include "DeclareStmt.h"
#include "Fragment.h"

class Clause;
class LocationNode;


#line 40 "parse.y"
typedef union {
	int			fInt;
	bool		fBool;
	Fragment*	fFragment;
	Stmt*		fStmt;
	BlockStmt*	fBlock;
	Symbol*		fSymbol;
	char*		fString;
	Expr*		fExpr;
	FunctionDef*	fFunction;
	CallStmt*	fCall;
	AsmStmt*	fAsmStmt;
	Field*		fField;
	LabeledStmt*	fLabeledStmt;
	DeclareStmt*	fDeclareStmt;
	LocationNode*	fLocation;
} YYSTYPE;
#line 59 "parse.y"

#include <stdlib.h>
#include "IfStmt.h"
#include "WhileStmt.h"
#include "AsmStmt.h"
#include "DoStmt.h"
#include "RepeatStmt.h"
#include "AssignStmt.h"
#include "TaskStmt.h"
#include "JumpStmt.h"
#include "SwitchStmt.h"
#include "ExprStmt.h"
#include "RCX_Constants.h"
#include "PreProc.h"
#include "parser.h"
#include "Program.h"
#include "parse_util.h"
#include "Program.h"
#include "IncDecExpr.h"
#include "AtomExpr.h"
#include "TypeExpr.h"
#include "Error.h"
#include "MonitorStmt.h"
#include "EventSrcExpr.h"
#include "SensorExpr.h"
#include "AssignMathStmt.h"
#include "ForStmt.h"
#include "RelExpr.h"
#include "NegateExpr.h"
#include "LogicalExpr.h"
#include "TernaryExpr.h"

#define yylex()		(gPreProc->Get(yylval))

static LexLocation sSavedLoc;

#line 145 "parse.y"

static void yyerror(const char *msg);

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		284
#define	YYFLAG		-32768
#define	YYNTBASE	90

#define YYTRANSLATE(x) ((unsigned)(x) <= 319 ? yytranslate[x] : 123)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    26,     2,     2,     2,    22,     9,     2,    84,
    35,    20,    19,    85,    18,     2,    21,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     3,    81,    12,
    86,    13,     4,    89,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    87,     2,    88,     8,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    82,     7,    83,    24,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     5,     6,    10,    11,
    14,    15,    16,    17,    23,    25,    27,    28,    29,    30,
    31,    32,    33,    34,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,    10,    14,    21,    28,    30,    31,
    37,    43,    45,    47,    48,    53,    56,    58,    61,    64,
    68,    70,    74,    76,    78,    82,    85,    91,    92,    97,
   100,   101,   103,   105,   108,   111,   113,   116,   123,   132,
   139,   146,   153,   162,   171,   180,   191,   197,   201,   206,
   213,   217,   220,   222,   226,   230,   234,   236,   237,   239,
   240,   242,   243,   246,   247,   250,   257,   260,   265,   269,
   271,   272,   276,   278,   281,   285,   289,   293,   297,   301,
   305,   309,   313,   317,   321,   325,   329,   333,   337,   341,
   345,   348,   351,   354,   358,   362,   365,   368,   373,   378,
   382,   385,   391,   394,   397,   400,   405,   410,   415,   418,
   426,   432,   433,   434,   438,   440,   441,   443,   446
};

static const short yyrhs[] = {    91,
     0,    91,    92,     0,     0,    73,    99,    81,     0,   120,
    95,   120,     0,   120,    93,    82,   104,    83,   120,     0,
    94,    74,    36,    84,    96,    35,     0,    78,     0,     0,
    42,    36,    84,    35,   102,     0,    43,    36,    84,    35,
   102,     0,    97,     0,    74,     0,     0,    97,    85,    98,
    36,     0,    98,    36,     0,    73,     0,    75,    73,     0,
    73,     9,     0,    75,    73,     9,     0,    76,     0,    99,
    85,   100,     0,   100,     0,   101,     0,   101,    86,   118,
     0,    36,   120,     0,    36,   120,    87,   118,    88,     0,
     0,    82,   103,   104,    83,     0,   104,   105,     0,     0,
    81,     0,   102,     0,   115,   105,     0,     1,    81,     0,
   106,     0,   107,   120,     0,    62,    84,   118,    35,   120,
   105,     0,    63,   120,   105,    62,    84,   118,    35,    81,
     0,    65,    84,   118,    35,   120,   105,     0,    66,    84,
   118,    35,   120,   105,     0,    61,    84,   118,    35,   120,
   105,     0,    61,    84,   118,    35,   120,   105,    33,   105,
     0,    69,   120,    84,   118,    35,   120,   102,   112,     0,
    71,   120,    84,   118,    35,   120,   102,   111,     0,    64,
    84,   109,    81,   110,    81,   109,    35,   120,   105,     0,
    72,    82,   121,    83,    81,     0,   119,    41,    81,     0,
    40,   119,    36,    81,     0,   120,    36,    84,   116,    35,
    81,     0,    73,    99,    81,     0,   108,    81,     0,   118,
     0,   118,    38,   118,     0,   118,    39,   118,     0,   118,
    86,   118,     0,   108,     0,     0,   118,     0,     0,   114,
     0,     0,   112,   113,     0,     0,    70,   102,     0,    70,
   120,    84,   118,    35,   102,     0,    70,   102,     0,   119,
    67,   118,     3,     0,   119,    68,     3,     0,   117,     0,
     0,   117,    85,   118,     0,   118,     0,    37,   119,     0,
   118,    19,   118,     0,   118,    18,   118,     0,   118,    20,
   118,     0,   118,    21,   118,     0,   118,     9,   118,     0,
   118,     7,   118,     0,   118,    22,   118,     0,   118,    16,
   118,     0,   118,    17,   118,     0,   118,     8,   118,     0,
   118,    10,   118,     0,   118,    14,   118,     0,   118,    15,
   118,     0,   118,    11,   118,     0,   118,    12,   118,     0,
   118,    13,   118,     0,    79,   119,     0,    80,   119,     0,
    26,   118,     0,   118,     6,   118,     0,   118,     5,   118,
     0,    18,   118,     0,    24,   118,     0,    28,    84,   118,
    35,     0,    29,    84,   118,    35,     0,    84,   118,    35,
     0,   120,    36,     0,   120,    36,    87,   118,    88,     0,
    89,   118,     0,   118,    27,     0,    27,   118,     0,    76,
    84,   118,    35,     0,    30,    84,   118,    35,     0,    31,
    84,   118,    35,     0,   120,    77,     0,    25,    84,   118,
    35,    87,   118,    88,     0,   118,     4,   118,     3,   118,
     0,     0,     0,   121,    85,   122,     0,   122,     0,     0,
   118,     0,     9,   118,     0,     9,   118,     3,   118,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   153,   157,   158,   161,   162,   163,   167,   170,   171,   174,
   175,   178,   179,   180,   183,   184,   187,   188,   189,   190,
   191,   195,   196,   199,   200,   203,   204,   207,   207,   210,
   211,   215,   216,   217,   218,   219,   220,   225,   226,   227,
   228,   229,   230,   231,   232,   233,   237,   238,   239,   240,
   241,   242,   246,   247,   248,   249,   253,   254,   257,   258,
   262,   263,   267,   268,   271,   272,   276,   279,   280,   283,
   284,   287,   288,   291,   292,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
   308,   309,   310,   311,   312,   314,   315,   317,   318,   320,
   321,   322,   323,   325,   326,   328,   329,   330,   331,   332,
   333,   336,   339,   342,   343,   344,   348,   349,   350
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","':'","'?'",
"OR","AND","'|'","'^'","'&'","REL_EQ","REL_NE","'<'","'>'","REL_LE","REL_GE",
"LEFT","RIGHT","'-'","'+'","'*'","'/'","'%'","UMINUS","'~'","INDIRECT","'!'",
"INCDEC","ABS","SIGN","TYPE","EVENT_SRC","LOWER_THAN_ELSE","ELSE","LOWER_THAN_EXPR_SHIFT",
"')'","ID","NUMBER","ASSIGN","ASSIGN2","TASKOP","JUMP","TASK","SUB","STRING",
"PP_DEFINE","PP_INCLUDE","NL","WS","PP_ARG","PP_UNKNOWN","PP_IFDEF","PP_IF",
"PP_ELSE","PP_ELIF","PP_ENDIF","PP_UNDEF","PP_PRAGMA","PP_GLOM","PP_ERROR","PP_WARNING",
"IF","WHILE","DO","FOR","REPEAT","SWITCH","CASE","DEFAULT","MONITOR","CATCH",
"ACQUIRE","ASM","INT","T_VOID","T_CONST","SENSOR","TASKID","NOLIST","CTRUE",
"CFALSE","';'","'{'","'}'","'('","','","'='","'['","']'","'@'","S","unit_list",
"unit","function_head","nolist_opt","fragment","args","arg_list","arg_type",
"var_list","var_item","var_decl","block","@1","stmt_list","stmt","control_stmt",
"misc_stmt","expr_stmt","opt_expr_stmt","opt_expr","opt_handler","handler_list",
"evt_handler","handler","label","params","param_list","expr","saveloc","loc",
"asm_list","asm_item", NULL
};
#endif

static const short yyr1[] = {     0,
    90,    91,    91,    92,    92,    92,    93,    94,    94,    95,
    95,    96,    96,    96,    97,    97,    98,    98,    98,    98,
    98,    99,    99,   100,   100,   101,   101,   103,   102,   104,
   104,   105,   105,   105,   105,   105,   105,   106,   106,   106,
   106,   106,   106,   106,   106,   106,   107,   107,   107,   107,
   107,   107,   108,   108,   108,   108,   109,   109,   110,   110,
   111,   111,   112,   112,   113,   113,   114,   115,   115,   116,
   116,   117,   117,   118,   118,   118,   118,   118,   118,   118,
   118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
   118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
   118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
   118,   119,   120,   121,   121,   121,   122,   122,   122
};

static const short yyr2[] = {     0,
     1,     2,     0,     3,     3,     6,     6,     1,     0,     5,
     5,     1,     1,     0,     4,     2,     1,     2,     2,     3,
     1,     3,     1,     1,     3,     2,     5,     0,     4,     2,
     0,     1,     1,     2,     2,     1,     2,     6,     8,     6,
     6,     6,     8,     8,     8,    10,     5,     3,     4,     6,
     3,     2,     1,     3,     3,     3,     1,     0,     1,     0,
     1,     0,     2,     0,     2,     6,     2,     4,     3,     1,
     0,     3,     1,     2,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     2,     2,     2,     3,     3,     2,     2,     4,     4,     3,
     2,     5,     2,     2,     2,     4,     4,     4,     2,     7,
     5,     0,     0,     3,     1,     0,     1,     2,     4
};

static const short yydefact[] = {     3,
   113,     0,     2,     9,   113,     0,    23,    24,     0,     0,
     8,     0,     0,   113,    26,     4,     0,   113,     0,     0,
    31,     0,     5,   113,    22,   113,   113,     0,   113,   113,
     0,     0,     0,     0,   112,     0,   112,   112,   113,   113,
    25,     0,     0,     0,     0,     0,     0,    96,    97,   113,
    93,   105,   113,   113,   113,   113,    74,   113,    91,    92,
     0,   103,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   104,   101,   109,     0,     0,     0,   112,     0,     0,
   113,     0,     0,     0,   113,   113,     0,     0,    32,    28,
   113,    33,    30,    36,   113,     0,     0,    53,     0,     0,
    14,    27,     0,     0,     0,     0,     0,     0,   100,     0,
    95,    94,    80,    84,    79,    85,    88,    89,    90,    86,
    87,    82,    83,    76,    75,    77,    78,    81,   113,    10,
    11,    35,     0,   113,   113,     0,   113,   113,   113,     0,
     0,   113,     0,    31,     6,    37,    52,    34,   113,   113,
   113,     0,   113,     0,   101,    17,    13,     0,    21,     0,
    12,     0,     0,    98,    99,   107,   108,   106,   113,     0,
     0,     0,     0,     0,    57,     0,     0,     0,   113,   113,
   113,   117,     0,   115,    51,     0,    54,    55,    56,    48,
     0,    69,   113,    19,    18,     7,     0,    16,   113,   111,
   102,    49,   113,   113,     0,   113,   113,   113,     0,     0,
   118,     0,   113,    29,    68,     0,    70,    73,    20,     0,
     0,     0,     0,   113,     0,    59,     0,     0,   113,   113,
   113,    47,   114,     0,   113,    15,   110,    42,    38,     0,
   113,    40,    41,     0,     0,   119,    50,    72,     0,     0,
     0,    64,    62,    43,    39,   113,    44,     0,    45,    61,
     0,   113,    63,    67,    46,    65,     0,   113,     0,     0,
    66,     0,     0,     0
};

static const short yydefgoto[] = {   282,
     1,     3,    12,    13,    14,   170,   171,   172,     6,     7,
     8,   102,   154,    45,   103,   104,   105,   106,   186,   235,
   269,   267,   273,   270,   107,   226,   227,   108,   109,    42,
   193,   194
};

static const short yypact[] = {-32768,
     7,   -24,-32768,   -19,-32768,   -79,-32768,   -69,   -11,     0,
-32768,   -37,   -18,-32768,   -26,-32768,   -24,   709,    -8,    -7,
-32768,    26,-32768,   709,-32768,   709,   709,     3,   709,   709,
     4,     5,     8,     9,-32768,    13,-32768,-32768,   709,   709,
  1350,   -31,    63,    66,     2,    29,   475,    94,    94,   709,
    94,    94,   709,   709,   709,   709,-32768,   709,-32768,-32768,
   795,    94,   709,   709,   709,   709,   709,   709,   709,   709,
   709,   709,   709,   709,   709,   709,   709,   709,   709,   709,
   709,-32768,    47,-32768,    55,    55,    58,-32768,    59,    60,
-32768,    64,    73,    74,-32768,-32768,    98,   -24,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   100,   389,   561,   -33,   -22,
    35,-32768,   827,   859,   891,   923,   955,   987,-32768,  1276,
  1396,  1417,  1437,   422,  1455,   276,   276,   111,   111,   111,
   111,    97,    97,   120,   120,    94,    94,    94,   709,-32768,
-32768,-32768,   148,   709,   709,   389,   614,   709,   709,   101,
   102,   577,   -70,-32768,-32768,-32768,-32768,-32768,   709,   709,
   709,   108,   709,   187,   -47,   182,-32768,   121,-32768,   158,
   112,   162,   113,-32768,-32768,-32768,-32768,-32768,   709,   499,
   118,  1019,  1051,   139,-32768,   122,  1083,  1115,   709,   709,
   709,  1350,   -67,-32768,-32768,   320,  1350,  1350,  1350,-32768,
  1301,-32768,    23,-32768,   193,-32768,    80,-32768,   709,  1374,
-32768,-32768,-32768,-32768,   123,   681,-32768,-32768,  1147,  1179,
  1326,   124,   600,-32768,-32768,   171,   125,  1350,-32768,   172,
   523,   389,   389,   709,   130,  1350,   389,   389,-32768,-32768,
   709,-32768,-32768,   133,   709,-32768,-32768,   185,-32768,  1211,
   695,-32768,-32768,    55,    55,  1350,-32768,  1350,   389,   134,
   184,-32768,   150,-32768,-32768,-32768,   152,    55,-32768,-32768,
   389,    55,-32768,-32768,-32768,-32768,   140,   709,  1243,    55,
-32768,   223,   225,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    19,   129,   211,
-32768,   -76,-32768,    75,   -50,-32768,-32768,  -146,   -21,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    96,   -16,    -1,
-32768,    10
};


#define	YYLAST		1482


static const short yytable[] = {     4,
   185,    16,    87,    15,    83,    17,    -1,   162,   140,   141,
   195,     5,    23,   165,    17,   222,    18,   223,    57,    26,
    59,    60,     9,    10,    19,    27,    28,    29,    30,    31,
    32,    33,    34,   163,   164,    20,   203,  -113,    35,   139,
    26,    88,  -112,   110,    21,    84,    27,    28,    29,    30,
    31,    32,    33,    34,    84,    22,   158,   -71,    11,    35,
    24,    46,    89,    90,    91,    92,    93,    94,  -112,  -112,
    95,   143,    96,    97,    98,    43,    44,    36,  -113,     2,
    37,    38,    99,   100,   101,    39,    50,    53,    54,   146,
    40,    55,    56,   150,   151,   184,    58,    85,    36,   155,
    86,    37,    38,   156,   185,   110,    39,   166,   167,   168,
   169,    40,   111,    41,    77,    78,    79,    80,    81,    47,
    82,    48,    49,    82,    51,    52,    75,    76,    77,    78,
    79,    80,    81,   139,    61,    62,   100,    82,   142,    79,
    80,    81,   144,   145,   110,   113,    82,   147,   114,   115,
   116,   117,   166,   118,   168,   169,   148,   149,   120,   121,
   122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
   132,   133,   134,   135,   136,   137,   138,   262,   263,   152,
   157,   248,   249,   181,   189,   190,   252,   253,   200,   202,
   204,   274,   206,   205,   110,   276,   207,   208,   212,   209,
   215,   229,   216,   281,   242,   244,   234,   246,   264,   245,
   251,   232,   233,   257,   265,   237,   238,   259,   266,   268,
   275,   272,   283,   278,   284,   230,   153,    25,   196,   261,
   110,   110,   243,     0,   180,   110,   110,   254,   255,   182,
   183,     0,     0,   187,   188,     0,     0,   192,     0,     0,
     0,     0,     0,     0,   197,   198,   199,   110,   201,     0,
     0,     0,     0,     0,   271,     0,     0,     0,     0,   110,
   277,     0,     0,     0,   210,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   219,   220,   221,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,   228,     0,
     0,     0,    82,     0,   231,     0,     0,     0,     0,     0,
     0,   236,     0,     0,     0,     0,     0,     0,   192,     0,
    87,     0,     0,     0,     0,     0,     0,     0,     0,   250,
     0,     0,     0,     0,     0,     0,   256,    26,     0,     0,
   258,     0,     0,    27,    28,    29,    30,    31,    32,    33,
    34,     0,     0,     0,     0,  -113,    35,     0,     0,    88,
  -112,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   279,     0,     0,     0,     0,     0,     0,
    89,    90,    91,    92,    93,    94,  -112,  -112,    95,    87,
    96,    97,    98,     0,     0,    36,  -113,     0,    37,    38,
    99,   100,   224,    39,     0,     0,    26,     0,    40,     0,
     0,     0,    27,    28,    29,    30,    31,    32,    33,    34,
     0,     0,     0,     0,  -113,    35,     0,     0,    88,  -112,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,     0,     0,     0,     0,    82,    89,
    90,    91,    92,    93,    94,  -112,  -112,    95,     0,    96,
    97,    98,     0,     0,    36,  -113,     0,    37,    38,    99,
   100,     0,    39,     0,     0,     0,     0,    40,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
     0,    82,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,     0,     0,     0,     0,    82,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,     0,     0,     0,     0,    82,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   112,     0,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,     0,     0,   191,   211,    82,     0,     0,
     0,     0,     0,     0,    26,     0,     0,     0,   159,   160,
    27,    28,    29,    30,    31,    32,    33,    34,   191,     0,
   247,     0,     0,    35,     0,     0,     0,    26,     0,     0,
     0,     0,     0,    27,    28,    29,    30,    31,    32,    33,
    34,    26,     0,     0,     0,     0,    35,    27,    28,    29,
    30,    31,    32,    33,    34,     0,   161,     0,     0,     0,
    35,     0,    36,     0,     0,    37,    38,     0,     0,  -116,
    39,  -116,     0,     0,     0,    40,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    36,     0,     0,    37,    38,
     0,     0,     0,    39,     0,     0,     0,     0,    40,    36,
     0,     0,    37,    38,   -58,     0,     0,    39,    26,     0,
     0,     0,    40,     0,    27,    28,    29,    30,    31,    32,
    33,    34,    26,     0,     0,     0,     0,    35,    27,    28,
    29,    30,    31,    32,    33,    34,    26,     0,     0,   -58,
     0,    35,    27,    28,    29,    30,    31,    32,    33,    34,
     0,     0,     0,     0,     0,    35,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    36,     0,     0,    37,
    38,   -60,     0,     0,    39,     0,     0,     0,     0,    40,
    36,     0,     0,    37,    38,     0,     0,     0,    39,     0,
     0,     0,     0,    40,    36,     0,     0,    37,    38,     0,
     0,     0,    39,     0,     0,     0,     0,    40,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
     0,    82,     0,     0,     0,     0,     0,     0,     0,   119,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
     0,   173,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,     0,     0,     0,     0,    82,     0,     0,     0,     0,
     0,     0,     0,   174,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,     0,     0,     0,     0,    82,     0,     0,
     0,     0,     0,     0,     0,   175,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,     0,     0,     0,     0,    82,
     0,     0,     0,     0,     0,     0,     0,   176,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
     0,    82,     0,     0,     0,     0,     0,     0,     0,   177,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
     0,   178,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,     0,     0,     0,     0,    82,     0,     0,     0,     0,
     0,     0,     0,   213,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,     0,     0,     0,     0,    82,     0,     0,
     0,     0,     0,     0,     0,   214,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,     0,     0,     0,     0,    82,
     0,     0,     0,     0,     0,     0,     0,   217,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
     0,    82,     0,     0,     0,     0,     0,     0,     0,   218,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
     0,   239,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,     0,     0,     0,     0,    82,     0,     0,     0,     0,
     0,     0,     0,   240,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,     0,     0,     0,     0,    82,     0,     0,
     0,     0,     0,     0,     0,   260,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,     0,     0,     0,     0,    82,
     0,     0,     0,     0,     0,     0,     0,   280,   179,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
     0,     0,    82,   225,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,     0,     0,     0,     0,    82,   241,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
     0,     0,    82,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,     0,     0,     0,     0,    82,-32768,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
    82,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
     0,     0,    82,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,     0,     0,    82,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,     0,     0,    82,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
     0,    82
};

static const short yycheck[] = {     1,
   147,    81,     1,     5,    36,    85,     0,    41,    85,    86,
    81,    36,    14,    36,    85,    83,    86,    85,    35,    18,
    37,    38,    42,    43,    36,    24,    25,    26,    27,    28,
    29,    30,    31,    67,    68,    36,    84,    36,    37,    87,
    18,    40,    41,    45,    82,    77,    24,    25,    26,    27,
    28,    29,    30,    31,    77,    74,   107,    35,    78,    37,
    87,    36,    61,    62,    63,    64,    65,    66,    67,    68,
    69,    88,    71,    72,    73,    84,    84,    76,    77,    73,
    79,    80,    81,    82,    83,    84,    84,    84,    84,    91,
    89,    84,    84,    95,    96,   146,    84,    35,    76,   101,
    35,    79,    80,   105,   251,   107,    84,    73,    74,    75,
    76,    89,    84,    18,    18,    19,    20,    21,    22,    24,
    27,    26,    27,    27,    29,    30,    16,    17,    18,    19,
    20,    21,    22,    87,    39,    40,    82,    27,    81,    20,
    21,    22,    84,    84,   146,    50,    27,    84,    53,    54,
    55,    56,    73,    58,    75,    76,    84,    84,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,   254,   255,    82,
    81,   232,   233,    36,    84,    84,   237,   238,    81,     3,
     9,   268,    35,    73,   196,   272,    85,    36,    81,    87,
    62,     9,    81,   280,    81,    35,    84,    36,   259,    85,
    81,   213,   214,    81,    81,   217,   218,    33,    35,    70,
   271,    70,     0,    84,     0,   207,    98,    17,   154,   251,
   232,   233,   223,    -1,   139,   237,   238,   239,   240,   144,
   145,    -1,    -1,   148,   149,    -1,    -1,   152,    -1,    -1,
    -1,    -1,    -1,    -1,   159,   160,   161,   259,   163,    -1,
    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,   271,
   272,    -1,    -1,    -1,   179,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   189,   190,   191,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,   203,    -1,
    -1,    -1,    27,    -1,   209,    -1,    -1,    -1,    -1,    -1,
    -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,
     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,
    -1,    -1,    -1,    -1,    -1,    -1,   241,    18,    -1,    -1,
   245,    -1,    -1,    24,    25,    26,    27,    28,    29,    30,
    31,    -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,
    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   278,    -1,    -1,    -1,    -1,    -1,    -1,
    61,    62,    63,    64,    65,    66,    67,    68,    69,     1,
    71,    72,    73,    -1,    -1,    76,    77,    -1,    79,    80,
    81,    82,    83,    84,    -1,    -1,    18,    -1,    89,    -1,
    -1,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
    -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
    72,    73,    -1,    -1,    76,    77,    -1,    79,    80,    81,
    82,    -1,    84,    -1,    -1,    -1,    -1,    89,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
    -1,    27,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    -1,    -1,    27,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    88,    -1,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,     9,    88,    27,    -1,    -1,
    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    38,    39,
    24,    25,    26,    27,    28,    29,    30,    31,     9,    -1,
    88,    -1,    -1,    37,    -1,    -1,    -1,    18,    -1,    -1,
    -1,    -1,    -1,    24,    25,    26,    27,    28,    29,    30,
    31,    18,    -1,    -1,    -1,    -1,    37,    24,    25,    26,
    27,    28,    29,    30,    31,    -1,    86,    -1,    -1,    -1,
    37,    -1,    76,    -1,    -1,    79,    80,    -1,    -1,    83,
    84,    85,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    76,    -1,    -1,    79,    80,
    -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,    89,    76,
    -1,    -1,    79,    80,    81,    -1,    -1,    84,    18,    -1,
    -1,    -1,    89,    -1,    24,    25,    26,    27,    28,    29,
    30,    31,    18,    -1,    -1,    -1,    -1,    37,    24,    25,
    26,    27,    28,    29,    30,    31,    18,    -1,    -1,    35,
    -1,    37,    24,    25,    26,    27,    28,    29,    30,    31,
    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,    -1,    79,
    80,    81,    -1,    -1,    84,    -1,    -1,    -1,    -1,    89,
    76,    -1,    -1,    79,    80,    -1,    -1,    -1,    84,    -1,
    -1,    -1,    -1,    89,    76,    -1,    -1,    79,    80,    -1,
    -1,    -1,    84,    -1,    -1,    -1,    -1,    89,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    35,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    35,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    35,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    35,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    35,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    35,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    35,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    35,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    35,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    27,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,    27,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    27,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    -1,    -1,    -1,    -1,    27,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,
    27,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    27,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
    -1,    -1,    -1,    27,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
    -1,    -1,    -1,    27,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
    -1,    27
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 153 "parse.y"
{ yyval.fInt = 0; ;
    break;}
case 4:
#line 161 "parse.y"
{ gProgram->AddGlobalDecls(yyvsp[-1].fBlock); ;
    break;}
case 5:
#line 162 "parse.y"
{ yyvsp[-1].fFragment->SetLocations(yyvsp[-2].fLocation, yyvsp[0].fLocation); ;
    break;}
case 6:
#line 163 "parse.y"
{ EndFunction(yyvsp[-4].fFunction, yyvsp[-2].fBlock, yyvsp[-5].fLocation, yyvsp[0].fLocation); ;
    break;}
case 7:
#line 167 "parse.y"
{ yyval.fFunction = BeginFunction(yyvsp[-1].fFunction, yyvsp[-3].fSymbol, yyvsp[-5].fBool); ;
    break;}
case 8:
#line 170 "parse.y"
{ yyval.fBool = 0; ;
    break;}
case 9:
#line 171 "parse.y"
{ yyval.fBool = 1; ;
    break;}
case 10:
#line 174 "parse.y"
{ yyval.fFragment = new Fragment(kRCX_TaskFragment, yyvsp[-3].fSymbol, yyvsp[0].fStmt); ;
    break;}
case 11:
#line 175 "parse.y"
{ yyval.fFragment = new Fragment(kRCX_SubFragment, yyvsp[-3].fSymbol, yyvsp[0].fStmt); ;
    break;}
case 13:
#line 179 "parse.y"
{ yyval.fFunction = new FunctionDef(); ;
    break;}
case 14:
#line 180 "parse.y"
{ yyval.fFunction = new FunctionDef(); ;
    break;}
case 15:
#line 183 "parse.y"
{ yyval.fFunction = yyvsp[-3].fFunction; 	DefineArg(yyval.fFunction, yyvsp[0].fSymbol, yyvsp[-1].fInt); ;
    break;}
case 16:
#line 184 "parse.y"
{ yyval.fFunction = new FunctionDef(); DefineArg(yyval.fFunction,yyvsp[0].fSymbol,yyvsp[-1].fInt); ;
    break;}
case 17:
#line 187 "parse.y"
{ yyval.fInt = FunctionDef::kIntegerArg; ;
    break;}
case 18:
#line 188 "parse.y"
{ yyval.fInt = FunctionDef::kConstantArg; ;
    break;}
case 19:
#line 189 "parse.y"
{ yyval.fInt = FunctionDef::kReferenceArg; ;
    break;}
case 20:
#line 190 "parse.y"
{ yyval.fInt = FunctionDef::kConstRefArg; ;
    break;}
case 21:
#line 191 "parse.y"
{ yyval.fInt = FunctionDef::kSensorArg; ;
    break;}
case 22:
#line 195 "parse.y"
{ yyvsp[-2].fBlock->Add(yyvsp[0].fStmt); yyval.fBlock = yyvsp[-2].fBlock; ;
    break;}
case 23:
#line 196 "parse.y"
{ yyval.fBlock = new BlockStmt(); yyval.fBlock->Add(yyvsp[0].fStmt); ;
    break;}
case 24:
#line 199 "parse.y"
{ yyval.fStmt = yyvsp[0].fDeclareStmt; ;
    break;}
case 25:
#line 200 "parse.y"
{ yyval.fStmt = yyvsp[-2].fDeclareStmt; yyvsp[-2].fDeclareStmt->SetInitialValue(yyvsp[0].fExpr); ;
    break;}
case 26:
#line 203 "parse.y"
{ yyval.fDeclareStmt = MakeDeclareStmt(yyvsp[-1].fSymbol, yyvsp[0].fLocation, 0); ;
    break;}
case 27:
#line 204 "parse.y"
{ yyval.fDeclareStmt = MakeDeclareStmt(yyvsp[-4].fSymbol, yyvsp[-3].fLocation, yyvsp[-1].fExpr); ;
    break;}
case 28:
#line 207 "parse.y"
{ BeginScope(); ;
    break;}
case 29:
#line 207 "parse.y"
{ yyval.fStmt = EndScope(yyvsp[-1].fBlock); ;
    break;}
case 30:
#line 210 "parse.y"
{ yyvsp[-1].fBlock->Add(yyvsp[0].fStmt); yyval.fBlock = yyvsp[-1].fBlock; ;
    break;}
case 31:
#line 211 "parse.y"
{ yyval.fBlock = new BlockStmt(); ;
    break;}
case 32:
#line 215 "parse.y"
{ yyval.fStmt = new BlockStmt(); ;
    break;}
case 34:
#line 217 "parse.y"
{ yyval.fStmt = yyvsp[-1].fLabeledStmt; yyvsp[-1].fLabeledStmt->SetStmt(yyvsp[0].fStmt); ;
    break;}
case 35:
#line 218 "parse.y"
{  yyerrok; yyval.fStmt = new BlockStmt(); ;
    break;}
case 37:
#line 220 "parse.y"
{ yyvsp[-1].fStmt->SetLocation(yyvsp[0].fLocation); ;
    break;}
case 38:
#line 225 "parse.y"
{ yyval.fStmt = new WhileStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 39:
#line 226 "parse.y"
{ yyval.fStmt = new DoStmt(yyvsp[-2].fExpr, yyvsp[-5].fStmt); yyval.fStmt->SetLocation(yyvsp[-6].fLocation); ;
    break;}
case 40:
#line 227 "parse.y"
{ yyval.fStmt = new RepeatStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 41:
#line 228 "parse.y"
{ yyval.fStmt = new SwitchStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 42:
#line 229 "parse.y"
{ yyval.fStmt = new IfStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 43:
#line 230 "parse.y"
{ yyval.fStmt = new IfStmt(yyvsp[-5].fExpr, yyvsp[-2].fStmt, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-3].fLocation); ;
    break;}
case 44:
#line 231 "parse.y"
{ yyval.fStmt = new MonitorStmt(yyvsp[-4].fExpr, yyvsp[-1].fStmt, yyvsp[0].fBlock, yyvsp[-6].fLocation->GetLoc()); delete yyvsp[-6].fLocation; yyval.fStmt->SetLocation(yyvsp[-2].fLocation); ;
    break;}
case 45:
#line 232 "parse.y"
{ yyval.fStmt = MakeAcquireStmt(yyvsp[-4].fExpr, yyvsp[-1].fStmt, yyvsp[0].fStmt, yyvsp[-6].fLocation); yyval.fStmt->SetLocation(yyvsp[-2].fLocation); ;
    break;}
case 46:
#line 233 "parse.y"
{ yyval.fStmt = new ForStmt(yyvsp[-7].fStmt, yyvsp[-5].fExpr, yyvsp[-3].fStmt, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 47:
#line 237 "parse.y"
{ yyval.fStmt = yyvsp[-2].fAsmStmt; ;
    break;}
case 48:
#line 238 "parse.y"
{ yyval.fStmt = new JumpStmt(yyvsp[-1].fInt, sSavedLoc); ;
    break;}
case 49:
#line 239 "parse.y"
{ yyval.fStmt = new TaskStmt((UByte)yyvsp[-3].fInt, yyvsp[-1].fSymbol, sSavedLoc); ;
    break;}
case 50:
#line 240 "parse.y"
{ yyval.fStmt = yyvsp[-2].fCall; yyvsp[-2].fCall->SetName(yyvsp[-4].fSymbol); yyvsp[-2].fCall->SetLocation(yyvsp[-5].fLocation->GetLoc()); delete yyvsp[-5].fLocation; ;
    break;}
case 51:
#line 241 "parse.y"
{ yyval.fStmt = yyvsp[-1].fBlock; ;
    break;}
case 53:
#line 246 "parse.y"
{ yyval.fStmt = new ExprStmt(yyvsp[0].fExpr); ;
    break;}
case 54:
#line 247 "parse.y"
{ CheckLValue(yyvsp[-2].fExpr); yyval.fStmt = new AssignMathStmt(yyvsp[-2].fExpr, (RCX_VarCode)yyvsp[-1].fInt, yyvsp[0].fExpr); ;
    break;}
case 55:
#line 248 "parse.y"
{ CheckLValue(yyvsp[-2].fExpr); yyval.fStmt = MakeAssign2Stmt(yyvsp[-2].fExpr, yyvsp[-1].fInt, yyvsp[0].fExpr); ;
    break;}
case 56:
#line 249 "parse.y"
{ CheckLValue(yyvsp[-2].fExpr); yyval.fStmt = new AssignStmt(yyvsp[-2].fExpr, yyvsp[0].fExpr); ;
    break;}
case 58:
#line 254 "parse.y"
{ yyval.fStmt = 0; ;
    break;}
case 60:
#line 258 "parse.y"
{ yyval.fExpr = 0; ;
    break;}
case 62:
#line 263 "parse.y"
{ yyval.fStmt = 0; ;
    break;}
case 63:
#line 267 "parse.y"
{ yyvsp[-1].fBlock->Add(yyvsp[0].fStmt); yyval.fBlock = yyvsp[-1].fBlock; ;
    break;}
case 64:
#line 268 "parse.y"
{ yyval.fBlock =  new BlockStmt(); ;
    break;}
case 65:
#line 271 "parse.y"
{ yyval.fStmt = yyvsp[0].fStmt; ;
    break;}
case 66:
#line 272 "parse.y"
{ yyval.fStmt = MakeCatchStmt(yyvsp[-2].fExpr, yyvsp[0].fStmt, yyvsp[-4].fLocation); ;
    break;}
case 67:
#line 276 "parse.y"
{ yyval.fStmt = yyvsp[0].fStmt; ;
    break;}
case 68:
#line 279 "parse.y"
{ yyval.fLabeledStmt = MakeCaseStmt(yyvsp[-1].fExpr, sSavedLoc); ;
    break;}
case 69:
#line 280 "parse.y"
{ yyval.fLabeledStmt = new LabeledStmt(LabeledStmt::kDefaultValue, sSavedLoc); ;
    break;}
case 71:
#line 284 "parse.y"
{ yyval.fCall = new CallStmt(); ;
    break;}
case 72:
#line 287 "parse.y"
{ yyval.fCall = yyvsp[-2].fCall; yyval.fCall->AddParam(yyvsp[0].fExpr); ;
    break;}
case 73:
#line 288 "parse.y"
{ yyval.fCall = new CallStmt(); yyval.fCall->AddParam(yyvsp[0].fExpr); ;
    break;}
case 74:
#line 291 "parse.y"
{ yyval.fExpr = new AtomExpr(kRCX_ConstantType, yyvsp[-1].fInt, sSavedLoc); ;
    break;}
case 75:
#line 292 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '+', yyvsp[0].fExpr); ;
    break;}
case 76:
#line 293 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '-', yyvsp[0].fExpr); ;
    break;}
case 77:
#line 294 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '*', yyvsp[0].fExpr); ;
    break;}
case 78:
#line 295 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '/', yyvsp[0].fExpr); ;
    break;}
case 79:
#line 296 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '&', yyvsp[0].fExpr); ;
    break;}
case 80:
#line 297 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '|', yyvsp[0].fExpr); ;
    break;}
case 81:
#line 298 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '%', yyvsp[0].fExpr); ;
    break;}
case 82:
#line 299 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, LEFT, yyvsp[0].fExpr); ;
    break;}
case 83:
#line 300 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, RIGHT, yyvsp[0].fExpr); ;
    break;}
case 84:
#line 301 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '^', yyvsp[0].fExpr); ;
    break;}
case 85:
#line 302 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kEqualTo, yyvsp[0].fExpr); ;
    break;}
case 86:
#line 303 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kLessOrEqual, yyvsp[0].fExpr); ;
    break;}
case 87:
#line 304 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kGreaterOrEqual, yyvsp[0].fExpr); ;
    break;}
case 88:
#line 305 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kNotEqualTo, yyvsp[0].fExpr); ;
    break;}
case 89:
#line 306 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kLessThan, yyvsp[0].fExpr); ;
    break;}
case 90:
#line 307 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kGreaterThan, yyvsp[0].fExpr); ;
    break;}
case 91:
#line 308 "parse.y"
{ yyval.fExpr = new AtomExpr(kRCX_ConstantType, 1, sSavedLoc); ;
    break;}
case 92:
#line 309 "parse.y"
{ yyval.fExpr = new AtomExpr(kRCX_ConstantType, 0, sSavedLoc); ;
    break;}
case 93:
#line 310 "parse.y"
{ yyval.fExpr = new NegateExpr(yyvsp[0].fExpr); ;
    break;}
case 94:
#line 311 "parse.y"
{ yyval.fExpr = new LogicalExpr(yyvsp[-2].fExpr, LogicalExpr::kLogicalAnd, yyvsp[0].fExpr); ;
    break;}
case 95:
#line 312 "parse.y"
{ yyval.fExpr = new LogicalExpr(yyvsp[-2].fExpr, LogicalExpr::kLogicalOr, yyvsp[0].fExpr); ;
    break;}
case 96:
#line 314 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(new AtomExpr(kRCX_ConstantType, 0, yyvsp[0].fExpr->GetLoc()), '-', yyvsp[0].fExpr); ;
    break;}
case 97:
#line 315 "parse.y"
{ yyval.fExpr = MakeUnaryExpr('~', yyvsp[0].fExpr); ;
    break;}
case 98:
#line 317 "parse.y"
{ yyval.fExpr = MakeUnaryExpr(ABS, yyvsp[-1].fExpr); ;
    break;}
case 99:
#line 318 "parse.y"
{ yyval.fExpr = MakeUnaryExpr(SIGN, yyvsp[-1].fExpr); ;
    break;}
case 100:
#line 320 "parse.y"
{ yyval.fExpr = yyvsp[-1].fExpr; ;
    break;}
case 101:
#line 321 "parse.y"
{ yyval.fExpr = MakeVarExpr(yyvsp[0].fSymbol, yyvsp[-1].fLocation); ;
    break;}
case 102:
#line 322 "parse.y"
{ yyval.fExpr = MakeArrayExpr(yyvsp[-3].fSymbol, yyvsp[-4].fLocation, yyvsp[-1].fExpr); ;
    break;}
case 103:
#line 323 "parse.y"
{ yyval.fExpr = MakeValueExpr(yyvsp[0].fExpr); ;
    break;}
case 104:
#line 325 "parse.y"
{ yyval.fExpr = new IncDecExpr(GetLValue(yyvsp[-1].fExpr), yyvsp[0].fInt, false, yyvsp[-1].fExpr->GetLoc()); ;
    break;}
case 105:
#line 326 "parse.y"
{ yyval.fExpr = new IncDecExpr(GetLValue(yyvsp[0].fExpr), yyvsp[-1].fInt, true, yyvsp[0].fExpr->GetLoc()); ;
    break;}
case 106:
#line 328 "parse.y"
{ yyval.fExpr = new SensorExpr(yyvsp[-1].fExpr); ;
    break;}
case 107:
#line 329 "parse.y"
{ yyval.fExpr = new TypeExpr(yyvsp[-1].fExpr); ;
    break;}
case 108:
#line 330 "parse.y"
{ yyval.fExpr = new EventSrcExpr(yyvsp[-1].fExpr); ;
    break;}
case 109:
#line 331 "parse.y"
{ yyval.fExpr = MakeTaskIdExpr(yyvsp[-1].fLocation); ;
    break;}
case 110:
#line 332 "parse.y"
{ yyval.fExpr = MakeIndirectExpr(yyvsp[-4].fExpr, yyvsp[-1].fExpr); ;
    break;}
case 111:
#line 333 "parse.y"
{ yyval.fExpr = new TernaryExpr(yyvsp[-4].fExpr, yyvsp[-2].fExpr, yyvsp[0].fExpr); ;
    break;}
case 112:
#line 336 "parse.y"
{ LexCurrentLocation(sSavedLoc); ;
    break;}
case 113:
#line 339 "parse.y"
{ yyval.fLocation = new LocationNode(); ;
    break;}
case 114:
#line 342 "parse.y"
{ yyval.fAsmStmt = yyvsp[-2].fAsmStmt; yyvsp[-2].fAsmStmt->Add(yyvsp[0].fField); ;
    break;}
case 115:
#line 343 "parse.y"
{ yyval.fAsmStmt = new AsmStmt(); yyval.fAsmStmt->Add(yyvsp[0].fField); ;
    break;}
case 116:
#line 344 "parse.y"
{ yyval.fAsmStmt = new AsmStmt(); ;
    break;}
case 117:
#line 348 "parse.y"
{ yyval.fField = MakeConstField(yyvsp[0].fExpr); ;
    break;}
case 118:
#line 349 "parse.y"
{ yyval.fField = new EAField(yyvsp[0].fExpr); ;
    break;}
case 119:
#line 350 "parse.y"
{ yyval.fField = new EAField(yyvsp[-2].fExpr, GetConstantValue(yyvsp[0].fExpr)); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 353 "parse.y"



void yyerror(const char *msg)
{
	Error(kErr_Parser, msg).RaiseLex();
}


